/***********************************************************************************
* Fancy Tasks: Plasmoid for fancy representing your tasks and launchers.
* Copyright (C) 2009 Michal Dutkiewicz aka Emdek <emdeck@gmail.com>
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*
***********************************************************************************/

#include "FancyTasksConfiguration.h"
#include "FancyTasksApplet.h"

FancyTasksConfiguration::FancyTasksConfiguration(QObject *parent) : QObject(parent)
{
}

void FancyTasksConfiguration::update(KConfigGroup configuration)
{
    m_moveAnimation = configuration.readEntry("moveAnimation", "zoomAnimation");
    m_parabolicMoveAnimation = configuration.readEntry("parabolicMoveAnimation", true);
    m_demandsAttentionAnimation = configuration.readEntry("demandsAttentionAnimation", "blinkAnimation");
    m_startupAnimation = configuration.readEntry("startupAnimation", "bounceAnimation");
    m_preallocateSpaceForIcons = configuration.readEntry("preallocateSpaceForIcons", false);
    m_drawReflections = configuration.readEntry("drawReflections", true);
    m_useThumbnails = configuration.readEntry("useThumbnails", false);
    m_titleLabelMode = configuration.readEntry("titleLabelMode", "never");
    m_showOnlyLaunchers = configuration.readEntry("showOnlyLaunchers", false);
    m_showOnlyCurrentDesktop = configuration.readEntry("showOnlyCurrentDesktop", false);
    m_showOnlyCurrentScreen = configuration.readEntry("showOnlyCurrentScreen", false);
    m_showOnlyMinimized = configuration.readEntry("showOnlyMinimized", false);
    m_groupingStrategy = static_cast<TaskManager::GroupManager::TaskGroupingStrategy>(configuration.readEntry("groupingStrategy", static_cast<int>(TaskManager::GroupManager::NoGrouping)));
    m_sortingStrategy = static_cast<TaskManager::GroupManager::TaskSortingStrategy>(configuration.readEntry("sortingStrategy", static_cast<int>(TaskManager::GroupManager::ManualSorting)));
}

TaskManager::GroupManager::TaskGroupingStrategy FancyTasksConfiguration::groupingStrategy()
{
    return m_groupingStrategy;
}

TaskManager::GroupManager::TaskSortingStrategy FancyTasksConfiguration::sortingStrategy()
{
    return m_sortingStrategy;
}

QString FancyTasksConfiguration::moveAnimation()
{
    return m_moveAnimation;
}

QString FancyTasksConfiguration::demandsAttentionAnimation()
{
    return m_demandsAttentionAnimation;
}

QString FancyTasksConfiguration::startupAnimation()
{
    return m_startupAnimation;
}

QString FancyTasksConfiguration::titleLabelMode()
{
    return m_titleLabelMode;
}

bool FancyTasksConfiguration::parabolicMoveAnimation()
{
    return m_parabolicMoveAnimation;
}

bool FancyTasksConfiguration::preallocateSpaceForIcons()
{
    return m_preallocateSpaceForIcons;
}

bool FancyTasksConfiguration::useThumbnails()
{
    return m_useThumbnails;
}

bool FancyTasksConfiguration::showOnlyLaunchers()
{
    return m_showOnlyLaunchers;
}

bool FancyTasksConfiguration::showOnlyCurrentDesktop()
{
    return m_showOnlyCurrentDesktop;
}

bool FancyTasksConfiguration::showOnlyCurrentScreen()
{
    return m_showOnlyCurrentScreen;
}

bool FancyTasksConfiguration::showOnlyMinimized()
{
    return m_showOnlyMinimized;
}

bool FancyTasksConfiguration::drawReflections()
{
    return m_drawReflections;
}
