/***********************************************************************************
* Fancy Tasks: Plasmoid for fancy representing your tasks and launchers.
* Copyright (C) 2009 Michal Dutkiewicz aka Emdek <emdeck@gmail.com>
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*
***********************************************************************************/

#ifndef FANCYTASKSCONFIGURATION_HEADER
#define FANCYTASKSCONFIGURATION_HEADER

#include <KConfigGroup>
#include <taskmanager/task.h>
#include <taskmanager/taskitem.h>
#include <taskmanager/taskactions.h>
#include <taskmanager/taskmanager.h>
#include <taskmanager/groupmanager.h>

class FancyTasksApplet;

class FancyTasksConfiguration : public QObject
{
    Q_OBJECT

    public:
        FancyTasksConfiguration(QObject *parent);

        void update(KConfigGroup configuration);
        TaskManager::GroupManager::TaskGroupingStrategy groupingStrategy();
        TaskManager::GroupManager::TaskSortingStrategy sortingStrategy();
        QString moveAnimation();
        QString demandsAttentionAnimation();
        QString startupAnimation();
        QString titleLabelMode();
        bool parabolicMoveAnimation();
        bool preallocateSpaceForIcons();
        bool useThumbnails();
        bool showOnlyLaunchers();
        bool showOnlyCurrentDesktop();
        bool showOnlyCurrentScreen();
        bool showOnlyMinimized();
        bool drawReflections();

    private:
        TaskManager::GroupManager::TaskGroupingStrategy m_groupingStrategy;
        TaskManager::GroupManager::TaskSortingStrategy m_sortingStrategy;
        QString m_moveAnimation;
        QString m_demandsAttentionAnimation;
        QString m_startupAnimation;
        QString m_titleLabelMode;
        bool m_parabolicMoveAnimation;
        bool m_preallocateSpaceForIcons;
        bool m_useThumbnails;
        bool m_showOnlyLaunchers;
        bool m_showOnlyCurrentDesktop;
        bool m_showOnlyCurrentScreen;
        bool m_showOnlyMinimized;
        bool m_drawReflections;
};

#endif
