/***********************************************************************************
* Fancy Tasks: Plasmoid for fancy representing your tasks and launchers.
* Copyright (C) 2009 Michal Dutkiewicz aka Emdek <emdeck@gmail.com>
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*
***********************************************************************************/

#ifndef FANCYTASKSSPACER_HEADER
#define FANCYTASKSSPACER_HEADER

#include <QGraphicsWidget>
#include <QDateTime>

class FancyTasksApplet;

class FancyTasksSpacer : public QGraphicsWidget
{
    Q_OBJECT

    public:
        FancyTasksSpacer(FancyTasksApplet *applet);

        int index();
        bool isVisible();

    protected:
        void paint(QPainter *painter, const QStyleOptionGraphicsItem *option, QWidget *widget);
        void dragEnterEvent(QGraphicsSceneDragDropEvent *event);
        void dragLeaveEvent(QGraphicsSceneDragDropEvent *event);
        void dropEvent(QGraphicsSceneDragDropEvent *event);

    public slots:
        void setSize(qreal size);
        void setIndex(int index);
        void show();
        void hide();

    private:
        FancyTasksApplet *m_applet;
        QDateTime m_lastShow;
        qreal m_size;
        int m_index;
        bool m_visible;
        bool m_canHide;
};

#endif
